// Automatically generated by xdrgen
// DO NOT EDIT or your changes may be overwritten

package org.stellar.sdk.xdr;


import java.io.IOException;

import com.google.common.base.Objects;

// === xdr source ============================================================

//  struct Operation
//  {
//      // sourceAccount is the account used to run the operation
//      // if not set, the runtime defaults to "sourceAccount" specified at
//      // the transaction level
//      MuxedAccount* sourceAccount;
//  
//      union switch (OperationType type)
//      {
//      case CREATE_ACCOUNT:
//          CreateAccountOp createAccountOp;
//      case PAYMENT:
//          PaymentOp paymentOp;
//      case PATH_PAYMENT_STRICT_RECEIVE:
//          PathPaymentStrictReceiveOp pathPaymentStrictReceiveOp;
//      case MANAGE_SELL_OFFER:
//          ManageSellOfferOp manageSellOfferOp;
//      case CREATE_PASSIVE_SELL_OFFER:
//          CreatePassiveSellOfferOp createPassiveSellOfferOp;
//      case SET_OPTIONS:
//          SetOptionsOp setOptionsOp;
//      case CHANGE_TRUST:
//          ChangeTrustOp changeTrustOp;
//      case ALLOW_TRUST:
//          AllowTrustOp allowTrustOp;
//      case ACCOUNT_MERGE:
//          MuxedAccount destination;
//      case INFLATION:
//          void;
//      case MANAGE_DATA:
//          ManageDataOp manageDataOp;
//      case BUMP_SEQUENCE:
//          BumpSequenceOp bumpSequenceOp;
//      case MANAGE_BUY_OFFER:
//          ManageBuyOfferOp manageBuyOfferOp;
//      case PATH_PAYMENT_STRICT_SEND:
//          PathPaymentStrictSendOp pathPaymentStrictSendOp;
//      case CREATE_CLAIMABLE_BALANCE:
//          CreateClaimableBalanceOp createClaimableBalanceOp;
//      case CLAIM_CLAIMABLE_BALANCE:
//          ClaimClaimableBalanceOp claimClaimableBalanceOp;
//      case BEGIN_SPONSORING_FUTURE_RESERVES:
//          BeginSponsoringFutureReservesOp beginSponsoringFutureReservesOp;
//      case END_SPONSORING_FUTURE_RESERVES:
//          void;
//      case REVOKE_SPONSORSHIP:
//          RevokeSponsorshipOp revokeSponsorshipOp;
//      }
//      body;
//  };

//  ===========================================================================
public class Operation implements XdrElement {
  public Operation () {}
  private MuxedAccount sourceAccount;
  public MuxedAccount getSourceAccount() {
    return this.sourceAccount;
  }
  public void setSourceAccount(MuxedAccount value) {
    this.sourceAccount = value;
  }
  private OperationBody body;
  public OperationBody getBody() {
    return this.body;
  }
  public void setBody(OperationBody value) {
    this.body = value;
  }
  public static void encode(XdrDataOutputStream stream, Operation encodedOperation) throws IOException{
    if (encodedOperation.sourceAccount != null) {
    stream.writeInt(1);
    MuxedAccount.encode(stream, encodedOperation.sourceAccount);
    } else {
    stream.writeInt(0);
    }
    OperationBody.encode(stream, encodedOperation.body);
  }
  public void encode(XdrDataOutputStream stream) throws IOException {
    encode(stream, this);
  }
  public static Operation decode(XdrDataInputStream stream) throws IOException {
    Operation decodedOperation = new Operation();
    int sourceAccountPresent = stream.readInt();
    if (sourceAccountPresent != 0) {
    decodedOperation.sourceAccount = MuxedAccount.decode(stream);
    }
    decodedOperation.body = OperationBody.decode(stream);
    return decodedOperation;
  }
  @Override
  public int hashCode() {
    return Objects.hashCode(this.sourceAccount, this.body);
  }
  @Override
  public boolean equals(Object object) {
    if (!(object instanceof Operation)) {
      return false;
    }

    Operation other = (Operation) object;
    return Objects.equal(this.sourceAccount, other.sourceAccount) && Objects.equal(this.body, other.body);
  }

  public static final class Builder {
    private MuxedAccount sourceAccount;
    private OperationBody body;

    public Builder sourceAccount(MuxedAccount sourceAccount) {
      this.sourceAccount = sourceAccount;
      return this;
    }

    public Builder body(OperationBody body) {
      this.body = body;
      return this;
    }

    public Operation build() {
      Operation val = new Operation();
      val.setSourceAccount(sourceAccount);
      val.setBody(body);
      return val;
    }
  }

  public static class OperationBody {
    public OperationBody () {}
    OperationType type;
    public OperationType getDiscriminant() {
      return this.type;
    }
    public void setDiscriminant(OperationType value) {
      this.type = value;
    }
    private CreateAccountOp createAccountOp;
    public CreateAccountOp getCreateAccountOp() {
      return this.createAccountOp;
    }
    public void setCreateAccountOp(CreateAccountOp value) {
      this.createAccountOp = value;
    }
    private PaymentOp paymentOp;
    public PaymentOp getPaymentOp() {
      return this.paymentOp;
    }
    public void setPaymentOp(PaymentOp value) {
      this.paymentOp = value;
    }
    private PathPaymentStrictReceiveOp pathPaymentStrictReceiveOp;
    public PathPaymentStrictReceiveOp getPathPaymentStrictReceiveOp() {
      return this.pathPaymentStrictReceiveOp;
    }
    public void setPathPaymentStrictReceiveOp(PathPaymentStrictReceiveOp value) {
      this.pathPaymentStrictReceiveOp = value;
    }
    private ManageSellOfferOp manageSellOfferOp;
    public ManageSellOfferOp getManageSellOfferOp() {
      return this.manageSellOfferOp;
    }
    public void setManageSellOfferOp(ManageSellOfferOp value) {
      this.manageSellOfferOp = value;
    }
    private CreatePassiveSellOfferOp createPassiveSellOfferOp;
    public CreatePassiveSellOfferOp getCreatePassiveSellOfferOp() {
      return this.createPassiveSellOfferOp;
    }
    public void setCreatePassiveSellOfferOp(CreatePassiveSellOfferOp value) {
      this.createPassiveSellOfferOp = value;
    }
    private SetOptionsOp setOptionsOp;
    public SetOptionsOp getSetOptionsOp() {
      return this.setOptionsOp;
    }
    public void setSetOptionsOp(SetOptionsOp value) {
      this.setOptionsOp = value;
    }
    private ChangeTrustOp changeTrustOp;
    public ChangeTrustOp getChangeTrustOp() {
      return this.changeTrustOp;
    }
    public void setChangeTrustOp(ChangeTrustOp value) {
      this.changeTrustOp = value;
    }
    private AllowTrustOp allowTrustOp;
    public AllowTrustOp getAllowTrustOp() {
      return this.allowTrustOp;
    }
    public void setAllowTrustOp(AllowTrustOp value) {
      this.allowTrustOp = value;
    }
    private MuxedAccount destination;
    public MuxedAccount getDestination() {
      return this.destination;
    }
    public void setDestination(MuxedAccount value) {
      this.destination = value;
    }
    private ManageDataOp manageDataOp;
    public ManageDataOp getManageDataOp() {
      return this.manageDataOp;
    }
    public void setManageDataOp(ManageDataOp value) {
      this.manageDataOp = value;
    }
    private BumpSequenceOp bumpSequenceOp;
    public BumpSequenceOp getBumpSequenceOp() {
      return this.bumpSequenceOp;
    }
    public void setBumpSequenceOp(BumpSequenceOp value) {
      this.bumpSequenceOp = value;
    }
    private ManageBuyOfferOp manageBuyOfferOp;
    public ManageBuyOfferOp getManageBuyOfferOp() {
      return this.manageBuyOfferOp;
    }
    public void setManageBuyOfferOp(ManageBuyOfferOp value) {
      this.manageBuyOfferOp = value;
    }
    private PathPaymentStrictSendOp pathPaymentStrictSendOp;
    public PathPaymentStrictSendOp getPathPaymentStrictSendOp() {
      return this.pathPaymentStrictSendOp;
    }
    public void setPathPaymentStrictSendOp(PathPaymentStrictSendOp value) {
      this.pathPaymentStrictSendOp = value;
    }
    private CreateClaimableBalanceOp createClaimableBalanceOp;
    public CreateClaimableBalanceOp getCreateClaimableBalanceOp() {
      return this.createClaimableBalanceOp;
    }
    public void setCreateClaimableBalanceOp(CreateClaimableBalanceOp value) {
      this.createClaimableBalanceOp = value;
    }
    private ClaimClaimableBalanceOp claimClaimableBalanceOp;
    public ClaimClaimableBalanceOp getClaimClaimableBalanceOp() {
      return this.claimClaimableBalanceOp;
    }
    public void setClaimClaimableBalanceOp(ClaimClaimableBalanceOp value) {
      this.claimClaimableBalanceOp = value;
    }
    private BeginSponsoringFutureReservesOp beginSponsoringFutureReservesOp;
    public BeginSponsoringFutureReservesOp getBeginSponsoringFutureReservesOp() {
      return this.beginSponsoringFutureReservesOp;
    }
    public void setBeginSponsoringFutureReservesOp(BeginSponsoringFutureReservesOp value) {
      this.beginSponsoringFutureReservesOp = value;
    }
    private RevokeSponsorshipOp revokeSponsorshipOp;
    public RevokeSponsorshipOp getRevokeSponsorshipOp() {
      return this.revokeSponsorshipOp;
    }
    public void setRevokeSponsorshipOp(RevokeSponsorshipOp value) {
      this.revokeSponsorshipOp = value;
    }

    public static final class Builder {
      private OperationType discriminant;
      private CreateAccountOp createAccountOp;
      private PaymentOp paymentOp;
      private PathPaymentStrictReceiveOp pathPaymentStrictReceiveOp;
      private ManageSellOfferOp manageSellOfferOp;
      private CreatePassiveSellOfferOp createPassiveSellOfferOp;
      private SetOptionsOp setOptionsOp;
      private ChangeTrustOp changeTrustOp;
      private AllowTrustOp allowTrustOp;
      private MuxedAccount destination;
      private ManageDataOp manageDataOp;
      private BumpSequenceOp bumpSequenceOp;
      private ManageBuyOfferOp manageBuyOfferOp;
      private PathPaymentStrictSendOp pathPaymentStrictSendOp;
      private CreateClaimableBalanceOp createClaimableBalanceOp;
      private ClaimClaimableBalanceOp claimClaimableBalanceOp;
      private BeginSponsoringFutureReservesOp beginSponsoringFutureReservesOp;
      private RevokeSponsorshipOp revokeSponsorshipOp;

      public Builder discriminant(OperationType discriminant) {
        this.discriminant = discriminant;
        return this;
      }

      public Builder createAccountOp(CreateAccountOp createAccountOp) {
        this.createAccountOp = createAccountOp;
        return this;
      }

      public Builder paymentOp(PaymentOp paymentOp) {
        this.paymentOp = paymentOp;
        return this;
      }

      public Builder pathPaymentStrictReceiveOp(PathPaymentStrictReceiveOp pathPaymentStrictReceiveOp) {
        this.pathPaymentStrictReceiveOp = pathPaymentStrictReceiveOp;
        return this;
      }

      public Builder manageSellOfferOp(ManageSellOfferOp manageSellOfferOp) {
        this.manageSellOfferOp = manageSellOfferOp;
        return this;
      }

      public Builder createPassiveSellOfferOp(CreatePassiveSellOfferOp createPassiveSellOfferOp) {
        this.createPassiveSellOfferOp = createPassiveSellOfferOp;
        return this;
      }

      public Builder setOptionsOp(SetOptionsOp setOptionsOp) {
        this.setOptionsOp = setOptionsOp;
        return this;
      }

      public Builder changeTrustOp(ChangeTrustOp changeTrustOp) {
        this.changeTrustOp = changeTrustOp;
        return this;
      }

      public Builder allowTrustOp(AllowTrustOp allowTrustOp) {
        this.allowTrustOp = allowTrustOp;
        return this;
      }

      public Builder destination(MuxedAccount destination) {
        this.destination = destination;
        return this;
      }

      public Builder manageDataOp(ManageDataOp manageDataOp) {
        this.manageDataOp = manageDataOp;
        return this;
      }

      public Builder bumpSequenceOp(BumpSequenceOp bumpSequenceOp) {
        this.bumpSequenceOp = bumpSequenceOp;
        return this;
      }

      public Builder manageBuyOfferOp(ManageBuyOfferOp manageBuyOfferOp) {
        this.manageBuyOfferOp = manageBuyOfferOp;
        return this;
      }

      public Builder pathPaymentStrictSendOp(PathPaymentStrictSendOp pathPaymentStrictSendOp) {
        this.pathPaymentStrictSendOp = pathPaymentStrictSendOp;
        return this;
      }

      public Builder createClaimableBalanceOp(CreateClaimableBalanceOp createClaimableBalanceOp) {
        this.createClaimableBalanceOp = createClaimableBalanceOp;
        return this;
      }

      public Builder claimClaimableBalanceOp(ClaimClaimableBalanceOp claimClaimableBalanceOp) {
        this.claimClaimableBalanceOp = claimClaimableBalanceOp;
        return this;
      }

      public Builder beginSponsoringFutureReservesOp(BeginSponsoringFutureReservesOp beginSponsoringFutureReservesOp) {
        this.beginSponsoringFutureReservesOp = beginSponsoringFutureReservesOp;
        return this;
      }

      public Builder revokeSponsorshipOp(RevokeSponsorshipOp revokeSponsorshipOp) {
        this.revokeSponsorshipOp = revokeSponsorshipOp;
        return this;
      }

      public OperationBody build() {
        OperationBody val = new OperationBody();
        val.setDiscriminant(discriminant);
        val.setCreateAccountOp(createAccountOp);
        val.setPaymentOp(paymentOp);
        val.setPathPaymentStrictReceiveOp(pathPaymentStrictReceiveOp);
        val.setManageSellOfferOp(manageSellOfferOp);
        val.setCreatePassiveSellOfferOp(createPassiveSellOfferOp);
        val.setSetOptionsOp(setOptionsOp);
        val.setChangeTrustOp(changeTrustOp);
        val.setAllowTrustOp(allowTrustOp);
        val.setDestination(destination);
        val.setManageDataOp(manageDataOp);
        val.setBumpSequenceOp(bumpSequenceOp);
        val.setManageBuyOfferOp(manageBuyOfferOp);
        val.setPathPaymentStrictSendOp(pathPaymentStrictSendOp);
        val.setCreateClaimableBalanceOp(createClaimableBalanceOp);
        val.setClaimClaimableBalanceOp(claimClaimableBalanceOp);
        val.setBeginSponsoringFutureReservesOp(beginSponsoringFutureReservesOp);
        val.setRevokeSponsorshipOp(revokeSponsorshipOp);
        return val;
      }
    }

    public static void encode(XdrDataOutputStream stream, OperationBody encodedOperationBody) throws IOException {
    //Xdrgen::AST::Identifier
    //OperationType
    stream.writeInt(encodedOperationBody.getDiscriminant().getValue());
    switch (encodedOperationBody.getDiscriminant()) {
    case CREATE_ACCOUNT:
    CreateAccountOp.encode(stream, encodedOperationBody.createAccountOp);
    break;
    case PAYMENT:
    PaymentOp.encode(stream, encodedOperationBody.paymentOp);
    break;
    case PATH_PAYMENT_STRICT_RECEIVE:
    PathPaymentStrictReceiveOp.encode(stream, encodedOperationBody.pathPaymentStrictReceiveOp);
    break;
    case MANAGE_SELL_OFFER:
    ManageSellOfferOp.encode(stream, encodedOperationBody.manageSellOfferOp);
    break;
    case CREATE_PASSIVE_SELL_OFFER:
    CreatePassiveSellOfferOp.encode(stream, encodedOperationBody.createPassiveSellOfferOp);
    break;
    case SET_OPTIONS:
    SetOptionsOp.encode(stream, encodedOperationBody.setOptionsOp);
    break;
    case CHANGE_TRUST:
    ChangeTrustOp.encode(stream, encodedOperationBody.changeTrustOp);
    break;
    case ALLOW_TRUST:
    AllowTrustOp.encode(stream, encodedOperationBody.allowTrustOp);
    break;
    case ACCOUNT_MERGE:
    MuxedAccount.encode(stream, encodedOperationBody.destination);
    break;
    case INFLATION:
    break;
    case MANAGE_DATA:
    ManageDataOp.encode(stream, encodedOperationBody.manageDataOp);
    break;
    case BUMP_SEQUENCE:
    BumpSequenceOp.encode(stream, encodedOperationBody.bumpSequenceOp);
    break;
    case MANAGE_BUY_OFFER:
    ManageBuyOfferOp.encode(stream, encodedOperationBody.manageBuyOfferOp);
    break;
    case PATH_PAYMENT_STRICT_SEND:
    PathPaymentStrictSendOp.encode(stream, encodedOperationBody.pathPaymentStrictSendOp);
    break;
    case CREATE_CLAIMABLE_BALANCE:
    CreateClaimableBalanceOp.encode(stream, encodedOperationBody.createClaimableBalanceOp);
    break;
    case CLAIM_CLAIMABLE_BALANCE:
    ClaimClaimableBalanceOp.encode(stream, encodedOperationBody.claimClaimableBalanceOp);
    break;
    case BEGIN_SPONSORING_FUTURE_RESERVES:
    BeginSponsoringFutureReservesOp.encode(stream, encodedOperationBody.beginSponsoringFutureReservesOp);
    break;
    case END_SPONSORING_FUTURE_RESERVES:
    break;
    case REVOKE_SPONSORSHIP:
    RevokeSponsorshipOp.encode(stream, encodedOperationBody.revokeSponsorshipOp);
    break;
    }
    }
    public void encode(XdrDataOutputStream stream) throws IOException {
      encode(stream, this);
    }
    public static OperationBody decode(XdrDataInputStream stream) throws IOException {
    OperationBody decodedOperationBody = new OperationBody();
    OperationType discriminant = OperationType.decode(stream);
    decodedOperationBody.setDiscriminant(discriminant);
    switch (decodedOperationBody.getDiscriminant()) {
    case CREATE_ACCOUNT:
    decodedOperationBody.createAccountOp = CreateAccountOp.decode(stream);
    break;
    case PAYMENT:
    decodedOperationBody.paymentOp = PaymentOp.decode(stream);
    break;
    case PATH_PAYMENT_STRICT_RECEIVE:
    decodedOperationBody.pathPaymentStrictReceiveOp = PathPaymentStrictReceiveOp.decode(stream);
    break;
    case MANAGE_SELL_OFFER:
    decodedOperationBody.manageSellOfferOp = ManageSellOfferOp.decode(stream);
    break;
    case CREATE_PASSIVE_SELL_OFFER:
    decodedOperationBody.createPassiveSellOfferOp = CreatePassiveSellOfferOp.decode(stream);
    break;
    case SET_OPTIONS:
    decodedOperationBody.setOptionsOp = SetOptionsOp.decode(stream);
    break;
    case CHANGE_TRUST:
    decodedOperationBody.changeTrustOp = ChangeTrustOp.decode(stream);
    break;
    case ALLOW_TRUST:
    decodedOperationBody.allowTrustOp = AllowTrustOp.decode(stream);
    break;
    case ACCOUNT_MERGE:
    decodedOperationBody.destination = MuxedAccount.decode(stream);
    break;
    case INFLATION:
    break;
    case MANAGE_DATA:
    decodedOperationBody.manageDataOp = ManageDataOp.decode(stream);
    break;
    case BUMP_SEQUENCE:
    decodedOperationBody.bumpSequenceOp = BumpSequenceOp.decode(stream);
    break;
    case MANAGE_BUY_OFFER:
    decodedOperationBody.manageBuyOfferOp = ManageBuyOfferOp.decode(stream);
    break;
    case PATH_PAYMENT_STRICT_SEND:
    decodedOperationBody.pathPaymentStrictSendOp = PathPaymentStrictSendOp.decode(stream);
    break;
    case CREATE_CLAIMABLE_BALANCE:
    decodedOperationBody.createClaimableBalanceOp = CreateClaimableBalanceOp.decode(stream);
    break;
    case CLAIM_CLAIMABLE_BALANCE:
    decodedOperationBody.claimClaimableBalanceOp = ClaimClaimableBalanceOp.decode(stream);
    break;
    case BEGIN_SPONSORING_FUTURE_RESERVES:
    decodedOperationBody.beginSponsoringFutureReservesOp = BeginSponsoringFutureReservesOp.decode(stream);
    break;
    case END_SPONSORING_FUTURE_RESERVES:
    break;
    case REVOKE_SPONSORSHIP:
    decodedOperationBody.revokeSponsorshipOp = RevokeSponsorshipOp.decode(stream);
    break;
    }
      return decodedOperationBody;
    }
    @Override
    public int hashCode() {
      return Objects.hashCode(this.createAccountOp, this.paymentOp, this.pathPaymentStrictReceiveOp, this.manageSellOfferOp, this.createPassiveSellOfferOp, this.setOptionsOp, this.changeTrustOp, this.allowTrustOp, this.destination, this.manageDataOp, this.bumpSequenceOp, this.manageBuyOfferOp, this.pathPaymentStrictSendOp, this.createClaimableBalanceOp, this.claimClaimableBalanceOp, this.beginSponsoringFutureReservesOp, this.revokeSponsorshipOp, this.type);
    }
    @Override
    public boolean equals(Object object) {
      if (!(object instanceof OperationBody)) {
        return false;
      }

      OperationBody other = (OperationBody) object;
      return Objects.equal(this.createAccountOp, other.createAccountOp) && Objects.equal(this.paymentOp, other.paymentOp) && Objects.equal(this.pathPaymentStrictReceiveOp, other.pathPaymentStrictReceiveOp) && Objects.equal(this.manageSellOfferOp, other.manageSellOfferOp) && Objects.equal(this.createPassiveSellOfferOp, other.createPassiveSellOfferOp) && Objects.equal(this.setOptionsOp, other.setOptionsOp) && Objects.equal(this.changeTrustOp, other.changeTrustOp) && Objects.equal(this.allowTrustOp, other.allowTrustOp) && Objects.equal(this.destination, other.destination) && Objects.equal(this.manageDataOp, other.manageDataOp) && Objects.equal(this.bumpSequenceOp, other.bumpSequenceOp) && Objects.equal(this.manageBuyOfferOp, other.manageBuyOfferOp) && Objects.equal(this.pathPaymentStrictSendOp, other.pathPaymentStrictSendOp) && Objects.equal(this.createClaimableBalanceOp, other.createClaimableBalanceOp) && Objects.equal(this.claimClaimableBalanceOp, other.claimClaimableBalanceOp) && Objects.equal(this.beginSponsoringFutureReservesOp, other.beginSponsoringFutureReservesOp) && Objects.equal(this.revokeSponsorshipOp, other.revokeSponsorshipOp) && Objects.equal(this.type, other.type);
    }

  }
}
